<template>
  <v-main>
    <showcase :corpus-list="corpusList" :client="client" />
  </v-main>
</template>

<script lang="ts">
import type { Client } from '@/client';
import { getClient } from '@/vuejs/components/utils/nav-tools';
import Showcase from '@/components/Showcase.vue';
import type CorpusData from '@/data/CorpusData';
import type { ShowcaseCard } from '@/components/ShowcaseItem.vue';
import type { Piece } from '@/data';
import { defineComponent } from 'vue';
import type { CorpusFormat } from '@/client/corpus';
import type { PieceFormat } from '@/formats/PieceParser';

export default defineComponent({
  components: {
    Showcase,
  },
  data() {
    const corpusList: Array<CorpusData|ShowcaseCard> = [];

    return {
      corpusList,
    };
  },
  computed: {
    client(): Client {
      return getClient(this.$route);
    },
  },
  async created() {
    try {
      const corpusData = await this.client.loadShowcaseCorpus();
      this.corpusList = await this.localizedShowCases(corpusData);
      await this.addCardForRandomPiece();
    } catch (error) {
      this.$router.push({
        name: 'Dezrann Local App',
        params: { piecePath: 'bwv847' },
      });
    }
  },
  methods: {
    async localizedShowCases(corpusData: CorpusData[]) {
      corpusData.forEach(async (corpus) => {
        if (corpus.showcase) {
          const { data } = await this.client.loadPiece(`${corpus.path}/${corpus.showcase}`, false);
          corpus.setLocalizedShowcaseName(data.getPieceAndTitle(this.$i18n.locale));
        }
      });
      return corpusData;
    },
    async showcaseCard(piecePath: string) {
      const { data } = await this.client.loadPiece(piecePath, false);
      return {
        title: data.getTitle(this.$i18n.locale),
        metadata: data.getMetadataOne(this.$i18n.locale),
        metadatatwo: data.getMetadataTwo(this.$i18n.locale),
        link: `/~/${piecePath}`,
        color: '#123456',
      } as ShowcaseCard;
    },
    randomPiecePath(pieces: PieceFormat[], corpus: CorpusData) {
      const randomPiecesWithoutShowcase = pieces.filter((piece) => corpus.showcase !== piece.id);
      const randomPieceId = Math.round(Math.random() * (randomPiecesWithoutShowcase.length - 1));
      return corpus.path + randomPiecesWithoutShowcase[randomPieceId].id;
    },
    getRandomCorpus() {
      const randomCorpusId = Math.round(Math.random() * (this.corpusList.length - 1));
      return this.corpusList[randomCorpusId] as CorpusData;
    },
    placeCard(card: ShowcaseCard) {
      const randomPosition = Math.floor(Math.random() * (this.corpusList.length - 1)) + 1;
      const newItemList = [...this.corpusList];
      newItemList.splice(randomPosition, 0, card);
      this.corpusList = [...newItemList];
    },
    async addCardForRandomPiece() {
      const randomCorpus = this.getRandomCorpus();
      const randomPieces = this.searchCorpus(randomCorpus.path);
      if (randomPieces) {
        const randomCard = await this.showcaseCard(
          this.randomPiecePath(randomPieces, randomCorpus),
        );
        this.placeCard(randomCard);
      }
    },
    flattenSubcorpora(corpus: CorpusFormat, pieces: PieceFormat[] = []) {
      if (corpus.corpora) {
        corpus.corpora.forEach((corpora) => this.flattenSubcorpora(corpora, pieces));
      }
      if (corpus.pieces) {
        pieces.push(...corpus.pieces.map((p) => ({ ...p, id: `${corpus.id}/${p.id}` })));
      }
      return pieces;
    },
    getSubCorpus(corpora: CorpusFormat[], corpusName: string) {
      return corpora.find((corpus) => corpus.id === corpusName) as CorpusFormat;
    },
    getDeepestSubCorpus(wordsInPath: string[], corpora: CorpusFormat[]): CorpusFormat {
      const subCorpus = this.getSubCorpus(corpora, wordsInPath[0]);
      if (wordsInPath.length === 1 || !subCorpus.corpora) {
        return subCorpus;
      }
      return this.getDeepestSubCorpus(wordsInPath.slice(1), subCorpus.corpora) as CorpusFormat;
    },
    getStoredCorpora() {
      const localStorageItem = localStorage.getItem('dezrann-recursive-corpus');
      if (!localStorageItem) return null;
      const { corpora } = JSON.parse(localStorageItem);
      return corpora;
    },
    searchCorpus(path: string): Array<PieceFormat> | null {
      const wordsInPath = path.split('/').filter((i) => i.length > 0);
      if (wordsInPath.length === 0) { return null; }
      const corpora = this.getStoredCorpora();
      if (!corpora) return null;

      const subCorpus = this.getDeepestSubCorpus(wordsInPath, corpora);
      if (subCorpus.pieces) { return subCorpus.pieces; }

      const flattenedPieces = this.flattenSubcorpora(subCorpus);
      return flattenedPieces.length > 0 ? flattenedPieces : null;
    },
  },
});

</script>
